import { Component } from 'react';
import type { ProgressBarProps, Values } from './props';
/**
---
category: components
---
**/
declare class ProgressBar extends Component<ProgressBarProps> {
    static readonly componentId = "ProgressBar";
    static allowedProps: readonly (keyof {
        screenReaderLabel: string;
        size?: "x-small" | "small" | "medium" | "large";
        valueMax?: Values["valueMax"];
        valueNow?: Values["valueNow"];
        formatScreenReaderValue?: (values: Values) => string;
        renderValue?: import("@instructure/shared-types").Renderable<Values>;
        color?: "primary" | "primary-inverse";
        meterColor?: ((values: Values) => import("./props").ProgressBarMeterColor) | import("./props").ProgressBarMeterColor;
        shouldAnimate?: boolean;
        margin?: import("@instructure/emotion").Spacing;
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        renderValueInside?: boolean;
    })[];
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        screenReaderLabel: string;
        size?: "x-small" | "small" | "medium" | "large";
        valueMax?: Values["valueMax"];
        valueNow?: Values["valueNow"];
        formatScreenReaderValue?: (values: Values) => string;
        renderValue?: import("@instructure/shared-types").Renderable<Values>;
        color?: "primary" | "primary-inverse";
        meterColor?: ((values: Values) => import("./props").ProgressBarMeterColor) | import("./props").ProgressBarMeterColor;
        shouldAnimate?: boolean;
        margin?: import("@instructure/emotion").Spacing;
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        renderValueInside?: boolean;
    }>;
    static defaultProps: {
        formatScreenReaderValue: ({ valueNow, valueMax }: Values) => string;
        size: string;
        valueMax: number;
        valueNow: number;
        as: string;
        color: string;
        shouldAnimate: boolean;
        meterColor: ({ valueNow, valueMax }: Values) => "success" | "brand";
    };
    ref: Element | null;
    componentDidMount(): void;
    componentDidUpdate(): void;
    handleRef: (el: Element | null) => void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default ProgressBar;
export { ProgressBar };
//# sourceMappingURL=index.d.ts.map