import { Component } from 'react';
import type { ProgressCircleProps, ProgressCircleState, Values } from './props';
/**
---
category: components
---
**/
declare class ProgressCircle extends Component<ProgressCircleProps, ProgressCircleState> {
    static readonly componentId = "ProgressCircle";
    static allowedProps: readonly (keyof {
        screenReaderLabel: string;
        size?: "x-small" | "small" | "medium" | "large";
        valueMax?: Values["valueMax"];
        valueNow?: Values["valueNow"];
        formatScreenReaderValue?: (values: Values) => string;
        renderValue?: import("@instructure/shared-types").Renderable<Values>;
        color?: "primary" | "primary-inverse";
        meterColor?: ((values: Values) => import("./props").ProgressCircleMeterColor) | import("./props").ProgressCircleMeterColor;
        margin?: import("@instructure/emotion").Spacing;
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        shouldAnimateOnMount?: boolean;
        animationDelay?: number;
    })[];
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        screenReaderLabel: string;
        size?: "x-small" | "small" | "medium" | "large";
        valueMax?: Values["valueMax"];
        valueNow?: Values["valueNow"];
        formatScreenReaderValue?: (values: Values) => string;
        renderValue?: import("@instructure/shared-types").Renderable<Values>;
        color?: "primary" | "primary-inverse";
        meterColor?: ((values: Values) => import("./props").ProgressCircleMeterColor) | import("./props").ProgressCircleMeterColor;
        margin?: import("@instructure/emotion").Spacing;
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        shouldAnimateOnMount?: boolean;
        animationDelay?: number;
    }>;
    static defaultProps: {
        formatScreenReaderValue: ({ valueNow, valueMax }: Values) => string;
        size: string;
        valueMax: number;
        valueNow: number;
        as: string;
        color: string;
        shouldAnimateOnMount: boolean;
        meterColor: ({ valueNow, valueMax }: Values) => "success" | "brand";
    };
    _timeouts: Array<ReturnType<typeof setTimeout>>;
    ref: Element | null;
    constructor(props: ProgressCircleProps);
    handleRef: (el: Element | null) => void;
    get makeStylesVariables(): {
        shouldAnimateOnMount: boolean;
    };
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default ProgressCircle;
export { ProgressCircle };
//# sourceMappingURL=index.d.ts.map